public class Link<T> {
    private T value;
    private Link<T> next;

    public Link(T element, Link<T> next) {
        this.value = element;
        this.next = next;
    }
    
    int occurrences(T element) {
        return this.next.occurrences(element) + (this.value.equals(element) ? 1 : 0);
    }

    int size() {
        return 1 + this.next.size();
    }

    Link<T> remove(T element) {
        if (this.value.equals(element)) {
            return this.next;
        } else {
            this.next = this.next.remove(element);
            return this;
        }
    }
}
